#ifndef USE_DDR_HEAP_MGR

#include <string.h>
#include "kmdw_memory.h"
#include "kmdw_console.h"

/* ddr malloc direction : from tail(bigger address) to head (smaller) */

static uint32_t s_ddr_addr_tail = 0;
static uint32_t s_ddr_addr_boundary = 0;


void kmdw_ddr_init(uint32_t start_addr, uint32_t end_addr)
{
    s_ddr_addr_tail = start_addr; //KDP_DDR_HEAP_HEAD_FOR_MALLOC+1 (address to the last used tail)
    s_ddr_addr_boundary = end_addr; //KDP_DDR_MODEL_RESERVED_END
}

uint32_t kmdw_ddr_reserve(uint32_t numbyte)
{
    uint32_t aligned_numbyte;
    uint32_t tail_tmp;

    if(numbyte == 0)
        return 0;

    if(s_ddr_addr_boundary == 0)
            return 0; //not initialized yet

    aligned_numbyte = ALIGN16(numbyte);
    tail_tmp = s_ddr_addr_tail;
    tail_tmp = ALIGN16_FLOOR(tail_tmp - aligned_numbyte);

    if(tail_tmp <= s_ddr_addr_boundary)
    {
        err_msg("[ERR] ddr malloc %x over (<) available bondary %x\n", tail_tmp, s_ddr_addr_boundary);
        return 0; 
    }
    s_ddr_addr_tail = tail_tmp;
    return s_ddr_addr_tail;
}

uint32_t kmdw_ddr_reserve64(uint32_t numbyte)
{
    uint32_t aligned_numbyte;
    uint32_t tail_tmp;

    if(numbyte == 0)
        return 0;

    if(s_ddr_addr_boundary == 0)
        return 0; //not initialized yet

    aligned_numbyte = ALIGN64(numbyte);
    tail_tmp = s_ddr_addr_tail;
    tail_tmp = ALIGN64_FLOOR(tail_tmp - aligned_numbyte);

    if(tail_tmp <= s_ddr_addr_boundary)
    {
        err_msg("[ERR] ddr malloc64 %x over (<) available bondary %x\n", tail_tmp, s_ddr_addr_boundary);
        return 0;
    }
    s_ddr_addr_tail = tail_tmp;
    return s_ddr_addr_tail;
}

#endif /* USE_DDR_HEAP_MGR */
