/*
 * Kneron NPU log buffer
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */

#ifndef __NPU_LOG_BUF_H__
#define __NPU_LOG_BUF_H__

#include "base.h"

typedef struct _npu_log_msg
{
    u8 len;
    u8 *pMsg;
} npu_log_msg_node_t;

typedef struct _npu_log_msg_pool
{
    u8 * pStart;
    u8 * pEnd;
    u32 wptr;    //this pointer is updated by NCPU only
    u32 rptr;    //this pointer is updated by SCPU only
} npu_log_buf_pool_t;


/* global control variable for log */
typedef struct _npu_log_ctl
{
    u16  nMaxNodes;
    u16  wNodeIdx;    // this index is updated by NPU only
    u16  rNodeIdx;    // this index is updated by SCPU only
    u8   *pNodeBase;  // place npu_log_msg_node_t[]
    s16  node_overfill;   // -1  Full, 0 normal
    s16  pool_overfill;   // -1 Full, - normal

    npu_log_buf_pool_t  buf_pool;

} npu_log_ctl_t;

#define NPU_LOG_CTL_SPACE    64

#define NPU_LOG_SHARE_NODE_MEM_LEN_IN_BYTES    (1024-NPU_LOG_CTL_SPACE)
#define NPU_LOG_SHARE_MSG_BUF_LEN_IN_BYTES     1024*4

#define NPU_LOG_MSG_TOTAL_BYTES (NPU_LOG_CTL_SPACE + NPU_LOG_SHARE_NODE_MEM_LEN_IN_BYTES + NPU_LOG_SHARE_MSG_BUF_LEN_IN_BYTES)

#define FLAG_LOG_BUF_START_LOG         BIT(0)

#endif  /* __NPU_LOG_BUF_H__ */

