/********************************************************************
 * Copyright (c) 2020 Kneron, Inc. All Rights Reserved.
 *
 * The information contained herein is property of Kneron, Inc.
 * Terms and conditions of usage are described in detail in Kneron
 * STANDARD SOFTWARE LICENSE AGREEMENT.
 *
 * Licensees are granted free, non-transferable use of the information.
 * NO WARRANTY of ANY KIND is provided. This heading must NOT be removed
 * from the file.
 ********************************************************************/
 //Include
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include "task_handler.h"
#include "kmdw_console.h"
#include "kmdw_memory.h"
#include "project.h"

 //Function
void task_initialize(void)
{
    uint32_t   index = 0;
    
    while (NULL != g_atKneronTaskPool[index].fpEntry)
    {
        osThreadAttr_t thread_attr;
        memset(&thread_attr, 0, sizeof(thread_attr));
        thread_attr.stack_size = g_atKneronTaskPool[index].dwStackSize;
        thread_attr.priority = g_atKneronTaskPool[index].dwPriority;
        *g_atKneronTaskPool[index].tTaskHandle = osThreadNew(g_atKneronTaskPool[index].fpEntry, NULL, &thread_attr);
        if (*g_atKneronTaskPool[index].tTaskHandle == NULL)
        {
            kmdw_printf("[******** ERROR ********] errand_thread not launched\n");
            //return -1; // Ooops, thread creation gets failed !
        }
        
        osMessageQueueAttr_t msgq_attr;
        memset(&msgq_attr, 0, sizeof(msgq_attr));

        *g_atKneronTaskPool[index].tQueueHandle = osMessageQueueNew(g_atKneronTaskPool[index].tQmsg_count, g_atKneronTaskPool[index].tQmsg_size, NULL);
        if (*g_atKneronTaskPool[index].tQueueHandle == NULL)
        {
            kmdw_printf("[errand] osMessageQueueNew failed\n");
        }
        
        index ++;
    }
}
